/*******************************************************************************
* File Name: Enabled.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Enabled_ALIASES_H) /* Pins Enabled_ALIASES_H */
#define CY_PINS_Enabled_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define Enabled_0			(Enabled__0__PC)
#define Enabled_0_PS		(Enabled__0__PS)
#define Enabled_0_PC		(Enabled__0__PC)
#define Enabled_0_DR		(Enabled__0__DR)
#define Enabled_0_SHIFT	(Enabled__0__SHIFT)
#define Enabled_0_INTR	((uint16)((uint16)0x0003u << (Enabled__0__SHIFT*2u)))

#define Enabled_INTR_ALL	 ((uint16)(Enabled_0_INTR))


#endif /* End Pins Enabled_ALIASES_H */


/* [] END OF FILE */
