/*******************************************************************************
* File Name: NeutralTiming.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_NeutralTiming_ALIASES_H) /* Pins NeutralTiming_ALIASES_H */
#define CY_PINS_NeutralTiming_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define NeutralTiming_0			(NeutralTiming__0__PC)
#define NeutralTiming_0_PS		(NeutralTiming__0__PS)
#define NeutralTiming_0_PC		(NeutralTiming__0__PC)
#define NeutralTiming_0_DR		(NeutralTiming__0__DR)
#define NeutralTiming_0_SHIFT	(NeutralTiming__0__SHIFT)
#define NeutralTiming_0_INTR	((uint16)((uint16)0x0003u << (NeutralTiming__0__SHIFT*2u)))

#define NeutralTiming_INTR_ALL	 ((uint16)(NeutralTiming_0_INTR))


#endif /* End Pins NeutralTiming_ALIASES_H */


/* [] END OF FILE */
