/*******************************************************************************
* File Name: Neutral.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Neutral_ALIASES_H) /* Pins Neutral_ALIASES_H */
#define CY_PINS_Neutral_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define Neutral_0			(Neutral__0__PC)
#define Neutral_0_PS		(Neutral__0__PS)
#define Neutral_0_PC		(Neutral__0__PC)
#define Neutral_0_DR		(Neutral__0__DR)
#define Neutral_0_SHIFT	(Neutral__0__SHIFT)
#define Neutral_0_INTR	((uint16)((uint16)0x0003u << (Neutral__0__SHIFT*2u)))

#define Neutral_INTR_ALL	 ((uint16)(Neutral_0_INTR))


#endif /* End Pins Neutral_ALIASES_H */


/* [] END OF FILE */
