/*******************************************************************************
* File Name: Samples.h
* Version 1.71
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_Samples_H)
#define CY_ISR_Samples_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void Samples_Start(void);
void Samples_StartEx(cyisraddress address);
void Samples_Stop(void);

CY_ISR_PROTO(Samples_Interrupt);

void Samples_SetVector(cyisraddress address);
cyisraddress Samples_GetVector(void);

void Samples_SetPriority(uint8 priority);
uint8 Samples_GetPriority(void);

void Samples_Enable(void);
uint8 Samples_GetState(void);
void Samples_Disable(void);

void Samples_SetPending(void);
void Samples_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the Samples ISR. */
#define Samples_INTC_VECTOR            ((reg32 *) Samples__INTC_VECT)

/* Address of the Samples ISR priority. */
#define Samples_INTC_PRIOR             ((reg32 *) Samples__INTC_PRIOR_REG)

/* Priority of the Samples interrupt. */
#define Samples_INTC_PRIOR_NUMBER      Samples__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable Samples interrupt. */
#define Samples_INTC_SET_EN            ((reg32 *) Samples__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the Samples interrupt. */
#define Samples_INTC_CLR_EN            ((reg32 *) Samples__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the Samples interrupt state to pending. */
#define Samples_INTC_SET_PD            ((reg32 *) Samples__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the Samples interrupt. */
#define Samples_INTC_CLR_PD            ((reg32 *) Samples__INTC_CLR_PD_REG)



#endif /* CY_ISR_Samples_H */


/* [] END OF FILE */
