/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "project.h"
#include <stdint.h>
#include <math.h>
#include <stdlib.h>

#include <PsocUSBExtensions.h>
#include <printf.h>

void my_putc ( void* p, char c){
  usb_send_buffered((uint8*)&c,1,0);
  UART_UartPutChar((uint8)c);
  }

void cmd_send(char c){
  my_putc(NULL,c);
}
char cmd_get(){
  return(usb_get_char_buffered());
}
int cmd_data_available(){
  return(usb_data_in_buffer||USBUART_DataIsReady());
}

/*char cmd_temp;
char cmd_get(){
  char temp;
  if (cmd_temp != 0){
    temp=cmd_temp;
    cmd_temp=0;
    return(temp);
  }
  else
    return((char)UART_UartGetChar()); //Zero means no data
}

int cmd_data_available(){
  if (!cmd_temp)
    cmd_temp=(char)UART_UartGetChar();
  return(cmd_temp != 0);
}
*/

#include <cmds.h>
#include <EVChargerCmds.h>



int main(void)
{
  int n=1,usb_initialised=0;;
  uint8 state=0;
    
  CyGlobalIntEnable; /* Enable global interrupts. */
  PWM_Start();
  TCPWM_Start();
  init_printf(NULL,my_putc);
  UART_Start();
  printf("Starting\n");

  USBUART_Start(0, USBUART_3V_OPERATION);
  printf("Started USBUART\n");

/*   for(;;)
    {
        if (0u != USBUART_IsConfigurationChanged())
        {
            printf("Enumerated\n");
            if (0u != USBUART_GetConfiguration())
            {
                USBUART_CDC_Init();
            }
        }
    }
*/



  while(!USBUART_GetConfiguration());
  while(!USBUART_IsLineChanged()); //Wait for the terminal to connect.
  while(!USBUART_IsLineChanged()); //Wait for the terminal to connect.
  while(1){
    if(USBUART_GetConfiguration()){
   	  if(!usb_initialised){
// Enumeration is done, enable OUT endpoint for receive data from Host
        USBUART_CDC_Init();
	    usb_initialised=1;
      }
	}else{
	  usb_initialised=0;
	}
	if(usb_initialised){
      check_msg();
	  usb_flush();
/*    TCPWM_WriteCompare(n);
    RelayL_Write(state);
    RelayN_Write(state);*/
    }
  }
  while(1){
    check_msg();
  }    
}
/* [] END OF FILE */
